package org.aspectjml.lang.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.Target;
import java.lang.annotation.ElementType;
import java.lang.annotation.Repeatable;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

@Repeatable(DeclareSoftDefinitions.class)
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.TYPE, ElementType.METHOD, ElementType.CONSTRUCTOR})
@Documented
public @interface DeclareSoft {

	/**
     * The name of the exception to be soften
     */
    String value() default "";

    /**
     * The pointcut expression where the exception is to be soften, overrides "value" when specified
     */
    String pointcut() default "";

    /**
     * The name of the exception to be soften
     */
    String exception() default "";
    
    
//    String argNames() default "";
}
